<template>
  <v-ons-page>
    <v-ons-toolbar>
      <div class="left">
        <nuxt-link to="/">
          <v-ons-icon icon="ion-ios-arrow-back" size="lg"></v-ons-icon>
        </nuxt-link>
      </div>
      <div class="center">New Message</div>
      <div class="right">
        <v-ons-toolbar-button icon="ion-navicon"></v-ons-toolbar-button>
      </div>
    </v-ons-toolbar>

    <div class="new-message-input-container">
      <input
        type="text"
        placeholder="Search username"
        v-model="username"
        @keyup="searchHandle"
        class="new-message-input"
      />
    </div>
    <v-ons-list>
      <v-ons-list-item v-for="handle in availableHandles" :key="handle">
        <nuxt-link v-bind:to="`/chathistory/${username}`" class="nuxt-link">@{{ handle }}</nuxt-link>
      </v-ons-list-item>
    </v-ons-list>

    <div class="current-friend-list">
      <h4>My Friend List</h4>
      <v-ons-list v-if="getAppState">
        <nuxt-link
          v-for="handle in getAppState.data.friends"
          :key="handle"
          v-bind:to="`/chathistory/${handle}`"
          class="nuxt-link"
        >
          <v-ons-list-item>
            <p>@{{ handle }}</p>
            <v-ons-icon icon="ion-ios-person" size="lg"></v-ons-icon>
          </v-ons-list-item>
        </nuxt-link>
      </v-ons-list>
    </div>
  </v-ons-page>
</template>

<script>
import Vue from "vue";
import "onsenui/css/onsenui.css";
import "onsenui/css/onsen-css-components.css";
import VueOnsen from "vue-onsenui/esm";
import OnsenComponents from "~/components/Onsen";
import ChatText from "~/components/ChatText";
import ChatInput from "~/components/ChatInput";
import utils from "../assets/utils";
import { mapGetters } from "vuex";

Vue.use(VueOnsen);
Object.values(OnsenComponents).forEach(c => Vue.component(c.name, c));

export default {
  components: {
    ChatText,
    ChatInput
  },
  validate({ params }) {
    return true;
  },
  data: function() {
    return {
      username: "",
      availableHandles: []
    };
  },
  computed: {
    ...mapGetters({
      getWallet: "wallet/getWallet",
      getAppState: "chat/getAppState",
      isUIReady: "chat/isUIReady"
    }),
    friend() {
      return this.$route.params.friend;
    }
  },
  mounted() {},
  methods: {
    async searchHandle() {
      if (this.username) this.username = this.username.toLowerCase();
      let queryAccount = await utils.queryAccount(this.username);
      if (queryAccount.account)
        this.availableHandles = [queryAccount.account.handle];
      else if (this.username.length === 0) this.availableHandles = [];
    }
  }
};
</script>

<style>
.new-message-input-container {
  height: 70px;
  background: #f2f2f2;
  display: flex;
  justify-content: center;
  align-items: center;
  width: 100%;
  /* position: fixed; */
  z-index: 100;
}
.new-message-input {
  height: 40px;
  width: 90%;
  max-width: 600px;
  padding: 5px 10px;
  background: #fff;
  border: 1px solid #dddddd;
  border-radius: 5px;
}
</style>
